git-pull.shon commit shallow: rewrite functions to take object_id arguments (580b04e)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# Fetch one or more remote refs and merge it/them into the current HEAD.
   6
   7USAGE='[-n | --no-stat] [--[no-]commit] [--[no-]squash] [--[no-]ff|--ff-only] [--[no-]rebase|--rebase=preserve] [-s strategy]... [<fetch-options>] <repo> <head>...'
   8LONG_USAGE='Fetch one or more remote refs and integrate it/them with the current HEAD.'
   9SUBDIRECTORY_OK=Yes
  10OPTIONS_SPEC=
  11. git-sh-setup
  12. git-sh-i18n
  13set_reflog_action "pull${1+ $*}"
  14require_work_tree_exists
  15cd_to_toplevel
  16
  17
  18die_conflict () {
  19    git diff-index --cached --name-status -r --ignore-submodules HEAD --
  20    if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
  21        die "$(gettext "Pull is not possible because you have unmerged files.
  22Please, fix them up in the work tree, and then use 'git add/rm <file>'
  23as appropriate to mark resolution and make a commit.")"
  24    else
  25        die "$(gettext "Pull is not possible because you have unmerged files.")"
  26    fi
  27}
  28
  29die_merge () {
  30    if [ $(git config --bool --get advice.resolveConflict || echo true) = "true" ]; then
  31        die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).
  32Please, commit your changes before you can merge.")"
  33    else
  34        die "$(gettext "You have not concluded your merge (MERGE_HEAD exists).")"
  35    fi
  36}
  37
  38test -z "$(git ls-files -u)" || die_conflict
  39test -f "$GIT_DIR/MERGE_HEAD" && die_merge
  40
  41bool_or_string_config () {
  42        git config --bool "$1" 2>/dev/null || git config "$1"
  43}
  44
  45strategy_args= diffstat= no_commit= squash= no_ff= ff_only=
  46log_arg= verbosity= progress= recurse_submodules= verify_signatures=
  47merge_args= edit= rebase_args=
  48curr_branch=$(git symbolic-ref -q HEAD)
  49curr_branch_short="${curr_branch#refs/heads/}"
  50rebase=$(bool_or_string_config branch.$curr_branch_short.rebase)
  51if test -z "$rebase"
  52then
  53        rebase=$(bool_or_string_config pull.rebase)
  54fi
  55
  56# Setup default fast-forward options via `pull.ff`
  57pull_ff=$(git config pull.ff)
  58case "$pull_ff" in
  59false)
  60        no_ff=--no-ff
  61        ;;
  62only)
  63        ff_only=--ff-only
  64        ;;
  65esac
  66
  67
  68dry_run=
  69while :
  70do
  71        case "$1" in
  72        -q|--quiet)
  73                verbosity="$verbosity -q" ;;
  74        -v|--verbose)
  75                verbosity="$verbosity -v" ;;
  76        --progress)
  77                progress=--progress ;;
  78        --no-progress)
  79                progress=--no-progress ;;
  80        -n|--no-stat|--no-summary)
  81                diffstat=--no-stat ;;
  82        --stat|--summary)
  83                diffstat=--stat ;;
  84        --log|--no-log)
  85                log_arg=$1 ;;
  86        --no-c|--no-co|--no-com|--no-comm|--no-commi|--no-commit)
  87                no_commit=--no-commit ;;
  88        --c|--co|--com|--comm|--commi|--commit)
  89                no_commit=--commit ;;
  90        -e|--edit)
  91                edit=--edit ;;
  92        --no-edit)
  93                edit=--no-edit ;;
  94        --sq|--squ|--squa|--squas|--squash)
  95                squash=--squash ;;
  96        --no-sq|--no-squ|--no-squa|--no-squas|--no-squash)
  97                squash=--no-squash ;;
  98        --ff)
  99                no_ff=--ff ;;
 100        --no-ff)
 101                no_ff=--no-ff ;;
 102        --ff-only)
 103                ff_only=--ff-only ;;
 104        -s=*|--s=*|--st=*|--str=*|--stra=*|--strat=*|--strate=*|\
 105                --strateg=*|--strategy=*|\
 106        -s|--s|--st|--str|--stra|--strat|--strate|--strateg|--strategy)
 107                case "$#,$1" in
 108                *,*=*)
 109                        strategy=$(expr "z$1" : 'z-[^=]*=\(.*\)') ;;
 110                1,*)
 111                        usage ;;
 112                *)
 113                        strategy="$2"
 114                        shift ;;
 115                esac
 116                strategy_args="${strategy_args}-s $strategy "
 117                ;;
 118        -X*)
 119                case "$#,$1" in
 120                1,-X)
 121                        usage ;;
 122                *,-X)
 123                        xx="-X $(git rev-parse --sq-quote "$2")"
 124                        shift ;;
 125                *,*)
 126                        xx=$(git rev-parse --sq-quote "$1") ;;
 127                esac
 128                merge_args="$merge_args$xx "
 129                ;;
 130        -r=*|--r=*|--re=*|--reb=*|--reba=*|--rebas=*|--rebase=*)
 131                rebase="${1#*=}"
 132                ;;
 133        -r|--r|--re|--reb|--reba|--rebas|--rebase)
 134                rebase=true
 135                ;;
 136        --no-r|--no-re|--no-reb|--no-reba|--no-rebas|--no-rebase)
 137                rebase=false
 138                ;;
 139        --recurse-submodules)
 140                recurse_submodules=--recurse-submodules
 141                ;;
 142        --recurse-submodules=*)
 143                recurse_submodules="$1"
 144                ;;
 145        --no-recurse-submodules)
 146                recurse_submodules=--no-recurse-submodules
 147                ;;
 148        --verify-signatures)
 149                verify_signatures=--verify-signatures
 150                ;;
 151        --no-verify-signatures)
 152                verify_signatures=--no-verify-signatures
 153                ;;
 154        --gpg-sign|-S)
 155                gpg_sign_args=-S
 156                ;;
 157        --gpg-sign=*)
 158                gpg_sign_args=$(git rev-parse --sq-quote "-S${1#--gpg-sign=}")
 159                ;;
 160        -S*)
 161                gpg_sign_args=$(git rev-parse --sq-quote "$1")
 162                ;;
 163        --d|--dr|--dry|--dry-|--dry-r|--dry-ru|--dry-run)
 164                dry_run=--dry-run
 165                ;;
 166        -h|--help-all)
 167                usage
 168                ;;
 169        *)
 170                # Pass thru anything that may be meant for fetch.
 171                break
 172                ;;
 173        esac
 174        shift
 175done
 176
 177case "$rebase" in
 178preserve)
 179        rebase=true
 180        rebase_args=--preserve-merges
 181        ;;
 182true|false|'')
 183        ;;
 184*)
 185        echo "Invalid value for --rebase, should be true, false, or preserve"
 186        usage
 187        exit 1
 188        ;;
 189esac
 190
 191error_on_no_merge_candidates () {
 192        exec >&2
 193
 194        if test true = "$rebase"
 195        then
 196                op_type=rebase
 197                op_prep=against
 198        else
 199                op_type=merge
 200                op_prep=with
 201        fi
 202
 203        upstream=$(git config "branch.$curr_branch_short.merge")
 204        remote=$(git config "branch.$curr_branch_short.remote")
 205
 206        if [ $# -gt 1 ]; then
 207                if [ "$rebase" = true ]; then
 208                        printf "There is no candidate for rebasing against "
 209                else
 210                        printf "There are no candidates for merging "
 211                fi
 212                echo "among the refs that you just fetched."
 213                echo "Generally this means that you provided a wildcard refspec which had no"
 214                echo "matches on the remote end."
 215        elif [ $# -gt 0 ] && [ "$1" != "$remote" ]; then
 216                echo "You asked to pull from the remote '$1', but did not specify"
 217                echo "a branch. Because this is not the default configured remote"
 218                echo "for your current branch, you must specify a branch on the command line."
 219        elif [ -z "$curr_branch" -o -z "$upstream" ]; then
 220                . git-parse-remote
 221                error_on_missing_default_upstream "pull" $op_type $op_prep \
 222                        "git pull <remote> <branch>"
 223        else
 224                echo "Your configuration specifies to $op_type $op_prep the ref '${upstream#refs/heads/}'"
 225                echo "from the remote, but no such ref was fetched."
 226        fi
 227        exit 1
 228}
 229
 230test true = "$rebase" && {
 231        if ! git rev-parse -q --verify HEAD >/dev/null
 232        then
 233                # On an unborn branch
 234                if test -f "$(git rev-parse --git-path index)"
 235                then
 236                        die "$(gettext "updating an unborn branch with changes added to the index")"
 237                fi
 238        else
 239                require_clean_work_tree "pull with rebase" "Please commit or stash them."
 240        fi
 241        oldremoteref= &&
 242        test -n "$curr_branch" &&
 243        . git-parse-remote &&
 244        remoteref="$(get_remote_merge_branch "$@" 2>/dev/null)" &&
 245        oldremoteref=$(git merge-base --fork-point "$remoteref" $curr_branch 2>/dev/null)
 246}
 247orig_head=$(git rev-parse -q --verify HEAD)
 248git fetch $verbosity $progress $dry_run $recurse_submodules --update-head-ok "$@" || exit 1
 249test -z "$dry_run" || exit 0
 250
 251curr_head=$(git rev-parse -q --verify HEAD)
 252if test -n "$orig_head" && test "$curr_head" != "$orig_head"
 253then
 254        # The fetch involved updating the current branch.
 255
 256        # The working tree and the index file is still based on the
 257        # $orig_head commit, but we are merging into $curr_head.
 258        # First update the working tree to match $curr_head.
 259
 260        eval_gettextln "Warning: fetch updated the current branch head.
 261Warning: fast-forwarding your working tree from
 262Warning: commit \$orig_head." >&2
 263        git update-index -q --refresh
 264        git read-tree -u -m "$orig_head" "$curr_head" ||
 265                die "$(eval_gettext "Cannot fast-forward your working tree.
 266After making sure that you saved anything precious from
 267$ git diff \$orig_head
 268output, run
 269$ git reset --hard
 270to recover.")"
 271
 272fi
 273
 274merge_head=$(sed -e '/  not-for-merge   /d' \
 275        -e 's/  .*//' "$GIT_DIR"/FETCH_HEAD | \
 276        tr '\012' ' ')
 277
 278case "$merge_head" in
 279'')
 280        error_on_no_merge_candidates "$@"
 281        ;;
 282?*' '?*)
 283        if test -z "$orig_head"
 284        then
 285                die "$(gettext "Cannot merge multiple branches into empty head")"
 286        fi
 287        if test true = "$rebase"
 288        then
 289                die "$(gettext "Cannot rebase onto multiple branches")"
 290        fi
 291        ;;
 292esac
 293
 294# Pulling into unborn branch: a shorthand for branching off
 295# FETCH_HEAD, for lazy typers.
 296if test -z "$orig_head"
 297then
 298        # Two-way merge: we claim the index is based on an empty tree,
 299        # and try to fast-forward to HEAD.  This ensures we will not
 300        # lose index/worktree changes that the user already made on
 301        # the unborn branch.
 302        empty_tree=4b825dc642cb6eb9a060e54bf8d69288fbee4904
 303        git read-tree -m -u $empty_tree $merge_head &&
 304        git update-ref -m "initial pull" HEAD $merge_head "$curr_head"
 305        exit
 306fi
 307
 308if test true = "$rebase"
 309then
 310        o=$(git show-branch --merge-base $curr_branch $merge_head $oldremoteref)
 311        if test "$oldremoteref" = "$o"
 312        then
 313                unset oldremoteref
 314        fi
 315fi
 316
 317case "$rebase" in
 318true)
 319        eval="git-rebase $diffstat $strategy_args $merge_args $rebase_args $verbosity"
 320        eval="$eval $gpg_sign_args"
 321        eval="$eval --onto $merge_head ${oldremoteref:-$merge_head}"
 322        ;;
 323*)
 324        eval="git-merge $diffstat $no_commit $verify_signatures $edit $squash $no_ff $ff_only"
 325        eval="$eval $log_arg $strategy_args $merge_args $verbosity $progress"
 326        eval="$eval $gpg_sign_args"
 327        eval="$eval FETCH_HEAD"
 328        ;;
 329esac
 330eval "exec $eval"